-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- Plugin Imports..
import "GaluhadPlugins.DropDown.DropDown";
import "GaluhadPlugins.DropDown.AddCallBack";

function print (Message)
	if Message ~= nil then Turbine.Shell.WriteLine(tostring(Message)) end;
end

wMain = Turbine.UI.Lotro.Window();
wMain:SetSize(260,220);
wMain:SetPosition((Turbine.UI.Display.GetWidth()/2)-(wMain:GetWidth()/2),50);
wMain:SetText("DropDown");
wMain:SetVisible(true);


-- DROPDOWN EXAMPLE ONE --------------------------------------------------------------------------------
local _list = {"First Item","Second Item","Third Item","Fourth Item","Fifth Item","Sixth Item","Seventh Item","Eighth Item","Ninth Item","Tenth Item"};
ddOne = DropDown(_list);
ddOne:SetParent(wMain);
ddOne:SetPosition(30,50);
ddOne:SetWidth(200);
ddOne:SetAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

ddOne.ItemChanged = function (Sender,Args)
	print("Index:"..Args.Index..",  Text:"..Args.Text);
	ddOne:Reset(); -- Scrolls back to the top of the list
end


-- DROPDOWN EXAMPLE TWO --------------------------------------------------------------------------------
ddTwo = DropDown({"Enabled","Disabled"});
ddTwo:SetParent(wMain);
ddTwo:SetPosition(30,80);

ddTwo.ItemChanged = function (Sender,Args)
	if Args.Text == "Disabled" then ddTwo:SetEnabled(false) end;
end


-- DROPDOWN EXAMPLE THREE --------------------------------------------------------------------------------
ddThree = DropDown()
ddThree:SetParent(wMain);
ddThree:SetPosition(30,110);
ddThree:SetText("Nothing to see here");

_list = {};
for i=1,50 do
	table.insert(_list,i);
end


-- DROPDOWN EXAMPLE FOUR --------------------------------------------------------------------------------
ddFour = DropDown(_list,"25");
ddFour:SetParent(wMain);
ddFour:SetPosition(30,140);
ddFour:SetWidth(60);
ddFour:SetMaxItems(20);

ddFour.ItemChanged = function (Sender,Args)
	print("Index:"..Args.Index..",  Text:"..Args.Text);
end


-- DROPDOWN EXAMPLE FIVE --------------------------------------------------------------------------------
-- A customised list, using GetListBox()
ddFour = DropDown();
ddFour:SetParent(wMain);
ddFour:SetPosition(30,170);
ddFour:SetWidth(200);
ddFour:SetText("Click to open");

ddList = ddFour:GetListBox();

for i=1, 15 do
	local itemContainer = Turbine.UI.Control();
	itemContainer:SetSize(ddList:GetWidth(),26);

	local colorBox = Turbine.UI.Control();
	colorBox:SetParent(itemContainer);
	colorBox:SetSize(22,22);
	colorBox:SetPosition(2,2);
	colorBox:SetMouseVisible(false);
	colorBox:SetBackColor(Turbine.UI.Color(math.random(),math.random(),math.random()));

	local itemLabel = Turbine.UI.Label();
	itemLabel:SetParent(itemContainer);
	itemLabel:SetSize(itemContainer:GetWidth()-26,itemContainer:GetHeight());
	itemLabel:SetPosition(26,0);
	itemLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	itemLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	itemLabel:SetMouseVisible(false);
	itemLabel:SetText("Custom List Item " .. tostring(i));

	itemContainer.MouseClick = function ()
		ddFour:SetText(itemLabel:GetText());
		ddFour:Close();
	end

	ddList:AddItem(itemContainer);
end

